import _useEffectState3 from "parsec-hooks/lib/effectStateHooks";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); enumerableOnly && (symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; })), keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = null != arguments[i] ? arguments[i] : {}; i % 2 ? ownKeys(Object(source), !0).forEach(function (key) { _defineProperty(target, key, source[key]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)) : ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }

/*
 * @Author: codingfly
 * @Description:
 * @Date: 2021-12-14 16:24:32
 * @LastEditTime: 2022-06-10 14:20:57
 * @FilePath: \remaxui\src\filter\index.tsx
 */
import React, { useMemo, cloneElement } from 'react';
import { View } from 'remax/one';
import classNames from 'classnames';
import styles from './styles/index.module.less';

function isReactElement(obj) {
  return obj && _typeof(obj === null || obj === void 0 ? void 0 : obj.props) === 'object';
}

export default (function (props) {
  var children = props.children,
      className = props.className,
      _props$showModal = props.showModal,
      showModal = _props$showModal === void 0 ? true : _props$showModal,
      onOpsVisible = props.onOpsVisible,
      _props$opsVisibleInde = props.opsVisibleIndex,
      opsVisibleIndex = _props$opsVisibleInde === void 0 ? -1 : _props$opsVisibleInde,
      style = props.style;

  var _useEffectState = _useEffectState3(opsVisibleIndex),
      _useEffectState2 = _slicedToArray(_useEffectState, 2),
      showOptions = _useEffectState2[0],
      setShowOptions = _useEffectState2[1];

  var handledChildren = useMemo(function () {
    return React.Children.map(children, function (item, index) {
      if (isReactElement(item)) {
        var childProps = _objectSpread(_objectSpread({}, item.props), {}, {
          onToggle: function onToggle(i) {
            setShowOptions(function (prev) {
              var showOptions = prev === index ? -1 : index;
              onOpsVisible === null || onOpsVisible === void 0 ? void 0 : onOpsVisible(showOptions === index, index);
              return showOptions;
            });
          },
          showOptions: showOptions === index
        });

        return /*#__PURE__*/cloneElement(item, childProps);
      }

      return item;
    });
  }, [children, onOpsVisible, setShowOptions, showOptions]);
  return /*#__PURE__*/React.createElement(React.Fragment, null, showOptions !== -1 && showModal && /*#__PURE__*/React.createElement(View, {
    className: styles.modal
  }), /*#__PURE__*/React.createElement(View, {
    className: classNames(styles.wrap, className),
    style: style
  }, handledChildren));
});